#include <ctype.h>
#include "fileread.h"

void filereadclass::ReadFile(char *InFileName, GlobalAttrib& glob,
						  CarArray& cars,OrderListClass& OrderList, SubsArray& subs){
   subsavail=false;
	FileName=InFileName;
   InputFile=fopen(FileName,"rt");
   fseek(InputFile,0,0);
   ReadGlobal(glob);
   ReadResource(cars);
   if (subsavail) ReadSubs(subs);
   ReadOrder(OrderList);
	fclose(InputFile);
}

void filereadclass::ReadGlobal( GlobalAttrib& glob){
	line=fgets(buffer,255,InputFile);
   i=8;
	glob.glsttime=Anumber(i,line,2);
	glob.glendtime=Anumber(i,line,2);
	glob.glmcap=Anumber(i,line,2);
}

void filereadclass::ReadResource(CarArray& cars){
	int j=0;

	line=fgets(buffer,255,InputFile);
	do{
	   i=9;
      j++;
      cars[j].RType=Anumber(i,line,1);
      cars[j].Stock=Anumber(i,line,1);
      cars[j].Utime=Anumber(i,line,1);
      cars[j].Mtime=Anumber(i,line,1);
      cars[j].Mcap=Anumber(i,line,1);
      cars[j].Crent=Anumber(i,line,1);
      cars[j].Cafix=Anumber(i,line,1);
      cars[j].Catd=Anumber(i,line,1);
      cars[j].Cbuy=Anumber(i,line,1);
      cars[j].Cstock=Anumber(i,line,1);
      cars[j].Cmaint=Anumber(i,line,1);
      cars[j].Maxbuy=Anumber(i,line,1);
		line=fgets(buffer,255,InputFile);
     }
   while ((line[0]!='s')&&(line[0]!='o'));
   cars[0].RType=j;
   if (line[0]=='s') subsavail=true;
}
void filereadclass::ReadSubs(SubsArray& subs){
	int j=0;
	do{
	   i=13;
      j++;
      subs[j].Rtype1=Anumber(i,line,2);
      subs[j].Rtype2=Anumber(i,line,2);
		line=fgets(buffer,255,InputFile);
     }
   while (line[0]!='o');
   subs[0].Rtype1=j;
}

int filereadclass::Anumber(int& i, const char *line, const int x){
int j=0,first=i,size=0;
long int r=0,factor[6]={1,10,100,1000,10000,100000};

do {size++; first++;} while((line[first]!=',')&&(line[first]!=')'));
do
{
 if (isdigit(line[i]))
 	r+=((toascii(line[i])-48)*factor[size-j-1]);
 j++;
 i++;
} while((line[i]!=',')&&(line[i]!=')'));
i+=x;
return r;
}

void filereadclass::ReadOrder(OrderListClass& OrderList){
orderstruct ordernode;
int k,amount;

do{
i=6;
ordernode.onumber=Anumber(i,line,2);
ordernode.sttime=Anumber(i,line,2);
ordernode.endtime=Anumber(i,line,2);
ordernode.require=Anumber(i,line,2);
ordernode.car[1]=Anumber(i,line,2);
ordernode.car[0]=1;
ordernode.alloc=false;
amount=ordernode.require;
for (k=1;k<=amount;k++){
 ordernode.require=1;
 ordernode.index=k;
 OrderList.add(ordernode);}
 line=fgets(buffer,255,InputFile);
} while ((line!=NULL)&&(line[0]!='\n'));
}
